/*============================================================================
                      QUEUES of INT  (with garbage collection)
The program uses the module for queues in the file `queue_module.cpp'.
The class queue is: class queue {public : cell* first; cell* last;};
The elements of a queue enter from the right and exit from the left:
         <= e1 e2 ... en <=
          |               |
         exit          entrance
=========================================================================== */
#include  <iostream.h>
typedef int QueueValues;
#include "queue_module.cpp" // we have a queue of integers as a pair of cell*
//----------------------------------------------------------------------------
//                    printing a queue
void printqueue(queue q)
{cout << " <=";
 if ((q.first)==NULL) {cout << " empty_queue";} else
 {cell* pointer=q.first;
  while (pointer!=NULL)
    {cout << " " << pointer->atom; pointer=pointer->next;};}; cout << " <=";}
//----------------------------------------------------------------------------
//                    main program
void main()
{queue q; emptyqueue(q);
cout << "An empty queue is printed as:"; printqueue(q); cout << "\n";
int x=2; cout << "\nThe value " << x <<" in the queue makes the queue:";
inqueue(x,q); printqueue(q); cout << "\n";
//----------------------------------------------------------------------------
outqueue(x,q);
cout << "\nTaking the first element out of that queue we get:";
cout << "\nElement: "<< x <<";  Queue: "; printqueue(q);
cout << "\nThis queue is";
if (!(isemptyqueue(q))) {cout << " NOT";}; cout << " empty.\n";
//----------------------------------------------------------------------------
x=6; cout << "\nThe value "<<x<<" in the empty_queue."; inqueue(x,q); x=3;
cout << " The value "<<x<<" in that queue."; inqueue(x,q);
cout << "\nResulting queue:"; printqueue(q); cout << "\n";
//----------------------------------------------------------------------------
outqueue(x,q); cout << "\nTaking the first element out of that queue we get:";
cout << "\nElement: "<< x <<";  Queue: "; printqueue(q); cout << "\n";
x=2; cout << "\nThe value "<< x <<" in that queue."; inqueue(x,q);
cout << " The value "<< x <<" in that queue."; inqueue(x,q);
cout << "\nResulting queue:"; printqueue(q); cout << "\nThis queue is";
if (!(isemptyqueue(q))) {cout << " NOT";}; cout << " empty.\n";
}
/* input:     output:
------------------------------------------------------------------------------
              An empty queue is printed as: <= empty_queue <=

              The value 2 in the queue makes the queue: <= 2 <=

              Taking the first element out of that queue we get:
              Element: 2;  Queue:  <= empty_queue <=
              This queue is empty.

              The value 6 in the empty_queue. The value 3 in that queue.
              Resulting queue: <= 6 3 <=

              Taking the first element out of that queue we get:
              Element: 6;  Queue:  <= 3 <=

              The value 2 in that queue. The value 2 in that queue.
              Resulting queue: <= 3 2 2 <=
              This queue is NOT empty.
--------------------------------------------------------------------------- */
